import { IKeyValue } from '../../../definitions.interface';
import { UniversalLayoutBuilderChildrenT, IUniversalLayoutBuilderConfiguration } from '../../../configurations-definitions.interface';
import { ILayoutViewBuilder } from './layout-builder.interface';
export declare abstract class UniversalLayoutViewBuilder<TNode> implements ILayoutViewBuilder<TNode> {
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} props
     * @param {Array<UniversalLayoutBuilderChildrenT<TNode>>} children
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {TNode}
     */
    abstract buildRowView(props: IKeyValue, children: Array<UniversalLayoutBuilderChildrenT<TNode>>, layoutConfig: IUniversalLayoutBuilderConfiguration<TNode>): TNode;
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} props
     * @param {Array<UniversalLayoutBuilderChildrenT<TNode>>} children
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {TNode}
     */
    abstract buildColumnView(props: IKeyValue, children: Array<UniversalLayoutBuilderChildrenT<TNode>>, layoutConfig: IUniversalLayoutBuilderConfiguration<TNode>): TNode;
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} props
     * @returns {TNode}
     */
    abstract buildSeparatorView(props: IKeyValue): TNode;
    /**
     * @stable [22.10.2018]
     * @param {UniversalLayoutBuilderChildrenT<TNode>} item
     * @returns {boolean}
     */
    isClonedItem(item: UniversalLayoutBuilderChildrenT<TNode>): boolean;
    /**
     * @stable [22.10.2018]
     * @param {TNode} item
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @param {IKeyValue} props
     * @returns {IKeyValue}
     */
    getClonedItemProps(item: TNode, layoutConfig: IUniversalLayoutBuilderConfiguration<TNode>, props: IKeyValue): IKeyValue;
    /**
     * @stable [22.10.2018]
     * @param {TNode} item
     * @param {IKeyValue} props
     * @returns {TNode}
     */
    cloneItem(item: TNode, props: IKeyValue): TNode;
    /**
     * @stable [22.10.2018]
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} config
     * @returns {string}
     */
    protected toFactorClassName(config: IUniversalLayoutBuilderConfiguration<TNode>): string;
}
