"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../util");
var base_1 = require("../base");
var layout_1 = require("../layout");
var plugin_1 = require("../plugin");
var Main = /** @class */ (function (_super) {
    __extends(Main, _super);
    /**
     * @stable [13.12.2018]
     * @param {IComponentProps} props
     */
    function Main(props) {
        var _this = _super.call(this, props) || this;
        _this.onScroll = _this.onScroll.bind(_this);
        _this.registerPlugin(plugin_1.StickyHeaderPlugin);
        _this.registerPlugin(plugin_1.PersistentScrollPlugin);
        return _this;
    }
    /**
     * @stable [12.10.2018]
     * @returns {JSX.Element}
     */
    Main.prototype.render = function () {
        var props = this.props;
        return (React.createElement("div", { className: util_1.toClassName('rac-main rac-flex-full', props.className) },
            React.createElement("div", { ref: this.getSelfRef(), className: 'rac-main-body-wrapper', onScroll: this.onScroll },
                React.createElement(layout_1.FlexLayout, { className: 'rac-main-body' }, props.children))));
    };
    /**
     * @stable [13.12.2018]
     */
    Main.prototype.onScroll = function () {
        // Each plugin should override this method
    };
    return Main;
}(base_1.BaseComponent));
exports.Main = Main;
//# sourceMappingURL=main.component.js.map