"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var R = require("ramda");
var util_1 = require("../../../util");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../picture/vue-index");
var vue_viewer_interface_1 = require("../vue-viewer.interface");
var VueFileViewer = /** @class */ (function (_super) {
    __extends(VueFileViewer, _super);
    /**
     * @stable [09.12.2018]
     */
    function VueFileViewer() {
        var _this = _super.call(this) || this;
        _this.getFileName = _this.getFileName.bind(_this);
        return _this;
    }
    /**
     * @stable [08.12.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueFileViewer.prototype.render = function (createElement) {
        return _super.prototype.render.call(this, createElement);
    };
    /**
     * @stable [09.12.2018]
     * @returns {string}
     */
    VueFileViewer.prototype.getPreviewTemplate = function () {
        return "\n      <vue-flex-layout :row=\"true\">\n          <vue-flex-layout :justifyContentCenter=\"true\">\n              <span class=\"vue-viewer-preview-label\">\n                    {{getLabel()}}\n              </span>\n              <span class=\"vue-viewer-preview-file-name\"\n                    @click=\"onOpenPopup\">\n                    {{getFileName()}}\n              </span>\n          </vue-flex-layout>\n          <vue-flex-layout :full=\"false\"\n                           :justifyContentCenter=\"true\">\n              <div class=\"vue-icon vue-icon-close\"\n                   @click=\"onRemove\">\n                    &nbsp;\n              </div>\n          </vue-flex-layout>\n      </vue-flex-layout>\n    ";
    };
    /**
     * @stable [09.12.2018]
     * @returns {IVueFileViewerTemplateMethodsEntity}
     */
    VueFileViewer.prototype.getTemplateMethods = function () {
        var _this = this;
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { getLabel: function () { return _this.t(_this.label); }, getFileName: this.getFileName });
    };
    /**
     * @stable [29.11.2018]
     */
    VueFileViewer.prototype.onOpenPopup = function () {
        _super.prototype.onOpenPopup.call(this);
    };
    /**
     * @stable [29.11.2018]
     */
    VueFileViewer.prototype.onClosePopup = function () {
        _super.prototype.onClosePopup.call(this);
    };
    VueFileViewer.prototype.onRemove = function () {
        _super.prototype.onRemove.call(this);
    };
    /**
     * @stable [09.12.2018]
     * @returns {string}
     */
    VueFileViewer.prototype.getFileName = function () {
        return (util_1.isFn(this.displayFileName) && !R.isNil(this.entity)
            ? this.displayFileName(this.entity)
            : util_1.nvl(this.fileName, this.t(this.settings.messages.unknownFileMessage)));
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueFileViewer.prototype, "label", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueFileViewer.prototype, "entity", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueFileViewer.prototype, "fileName", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueFileViewer.prototype, "displayFileName", void 0);
    VueFileViewer = __decorate([
        vue_index_1.ComponentName('vue-file-viewer'),
        vue_property_decorator_1.Component(vue_viewer_interface_1.vueViewerComponentConfigFactory()),
        __metadata("design:paramtypes", [])
    ], VueFileViewer);
    return VueFileViewer;
}(vue_index_2.VueBasePictureViewer));
//# sourceMappingURL=vue-file-viewer.component.js.map