"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var dragscroll = require("dragscroll");
var env_1 = require("../../../env");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../../base/vue-index");
var universal_pdf_plugin_1 = require("./universal-pdf.plugin");
var VuePdfViewer = /** @class */ (function (_super) {
    __extends(VuePdfViewer, _super);
    /**
     * @stable [14.11.2018]
     */
    function VuePdfViewer() {
        var _this = _super.call(this) || this;
        _this.pdfPlugin = new universal_pdf_plugin_1.UniversalPdfPlugin("" + _this.settings.pdfWorkerDirectoryUrl + _this.pdfWorkerJs + "?_dc=" + env_1.ENV.appVersion, function () { return _this.$refs.canvas; });
        return _this;
    }
    /**
     * @stable [14.11.2018]
     */
    VuePdfViewer.prototype.mounted = function () {
        dragscroll.reset();
        this.pdfPlugin
            .setScale(this.$data.scale)
            .setSrc(this.src)
            .loadDocument();
    };
    /**
     * @stable [18.11.2018]
     */
    VuePdfViewer.prototype.beforeDestroy = function () {
        this.pdfPlugin.cancel();
    };
    /**
     * @stable [11.11.2018]
     * @param {MouseEvent} event
     */
    VuePdfViewer.prototype.onClick = function (event) {
        this.$emit('click', event);
    };
    /**
     * @stable [14.11.2018]
     */
    VuePdfViewer.prototype.onScaleIncrease = function () {
        this.onChangeScale(this.scaleFactor);
    };
    /**
     * @stable [14.11.2018]
     */
    VuePdfViewer.prototype.onScaleDecrease = function () {
        this.onChangeScale(-this.scaleFactor);
    };
    /**
     * @stable [14.11.2018]
     * @param {number} scale
     */
    VuePdfViewer.prototype.onChangeScale = function (scale) {
        this.$data.scale += scale;
        this.pdfPlugin
            .setScale(this.$data.scale)
            .refreshPage();
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VuePdfViewer.prototype, "text", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VuePdfViewer.prototype, "src", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return .5; } }),
        __metadata("design:type", Number)
    ], VuePdfViewer.prototype, "scaleFactor", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'pdf.worker.min.js'; } }),
        __metadata("design:type", String)
    ], VuePdfViewer.prototype, "pdfWorkerJs", void 0);
    VuePdfViewer = __decorate([
        vue_index_1.ComponentName('vue-pdf-viewer'),
        vue_property_decorator_1.Component({
            data: function () { return ({
                scale: 1,
            }); },
            template: "\n    <vue-flex-layout class=\"vue-pdf-viewer\">\n       <vue-flex-layout class=\"vue-viewer-canvas dragscroll\">\n         <canvas ref=\"canvas\"\n                 class=\"rac-absolute\"/>\n       </vue-flex-layout>\n       <div class=\"vue-viewer-scale-action\n                   vue-icon-search-zoom-plus\n                   vue-icon\n                   rac-no-user-select\"\n            @click=\"onScaleIncrease\">\n          &nbsp;\n       </div>\n       <div class=\"vue-viewer-scale-action\n                   vue-icon-search-zoom-minus\n                   vue-icon\n                   rac-no-user-select\"\n            @click=\"onScaleDecrease\">\n          &nbsp;\n       </div>\n    </vue-flex-layout>\n  ",
        }),
        __metadata("design:paramtypes", [])
    ], VuePdfViewer);
    return VuePdfViewer;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-pdf-viewer.component.js.map