"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_smart_logger_1 = require("ts-smart-logger");
var di_1 = require("../di");
var Lock = /** @class */ (function () {
    /**
     * @stable [14.06.2018]
     */
    function Lock() {
        this.onBeforeUnload = this.onBeforeUnload.bind(this);
    }
    Lock_1 = Lock;
    /**
     * @stable [26.05.2018]
     */
    Lock.prototype.lock = function () {
        if (this.locked) {
            return;
        }
        window.onbeforeunload = this.onBeforeUnload;
        this.eventManager.add(window, 'beforeunload', this.onBeforeUnload);
        this.locked = true;
        Lock_1.logger.debug('[$Lock][lock] The app has been locked to unload.');
    };
    /**
     * @stable [26.05.2018]
     */
    Lock.prototype.unlock = function () {
        if (!this.locked) {
            return;
        }
        window.onbeforeunload = null;
        this.eventManager.remove(window, 'beforeunload', this.onBeforeUnload);
        this.locked = false;
        Lock_1.logger.debug('[$Lock][lock] The app has been unlocked to unload.');
    };
    /**
     * @stable [26.05.2018]
     * @param {Event} event
     */
    Lock.prototype.onBeforeUnload = function (event) {
        event.preventDefault();
        return this.t('The app is offline. Please, don\'t refresh the page!');
    };
    var Lock_1;
    Lock.logger = ts_smart_logger_1.LoggerFactory.makeLogger('Lock');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Translate),
        __metadata("design:type", Function)
    ], Lock.prototype, "t", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.EventManager),
        __metadata("design:type", Object)
    ], Lock.prototype, "eventManager", void 0);
    Lock = Lock_1 = __decorate([
        di_1.provideInSingleton(Lock_1),
        __metadata("design:paramtypes", [])
    ], Lock);
    return Lock;
}());
exports.Lock = Lock;
//# sourceMappingURL=lock.service.js.map